// WideMargin. Simple fast bible software.
// Copyright (C) 2011  Daniel Hughes
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Reflection;
using WideMargin.Database;

namespace WideMargin.Markup
{
	public class DailyReadings
	{
		BibleDatabase _bibleDatabase;
		
		public DailyReadings (BibleDatabase bibleDatabase)
		{
			_bibleDatabase = bibleDatabase;
		}
		
		public string GetDailyReadingsHtml()
		{
			DaylyReading[] readings = _bibleDatabase.GetDaylyReading(DateTime.Now).ToArray();
			
			var template = new HtmlTemplate();
				
			string readingsTemplate = Resources.ReadEmbeddedText("DailyReadingsTemplate.html");
			
			template.AddParameter("Target1", readings[0].FirstVerse);
			template.AddParameter("Reading1", readings[0].Chapters);
			
			template.AddParameter("Target2", readings[1].FirstVerse);
			template.AddParameter("Reading2", readings[1].Chapters);
			
			template.AddParameter("Target3", readings[2].FirstVerse);
			template.AddParameter("Reading3", readings[2].Chapters);
			
			template.AddParameter("Javascript", Resources.ReadEmbeddedText("MouseButton.js"));
			
			return template.Generate(readingsTemplate);
		}
	}
}

