// WideMargin. Simple fast bible software.
// Copyright (C) 2011  Daniel Hughes
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
using System;
using System.Collections.Generic;
using System.Linq;
using SharpSword;

namespace WideMargin.Database.Markup
{
	public class SearchResult
	{
		public SearchResult ()
		{
		}
		
		public string GetVersesHtml(IEnumerable<IVerse> verses, string searchText, IVerseIdentifier bookResult)
		{
			string searchResultTemplate = Resources.ReadEmbeddedText("SearchResult.html");
			
			var template = new HtmlTemplate();
			template.AddParameter("SearchResultFragment", GetVersesFragment(verses, searchText));
		
			template.AddParameter("BookResultFragment", new BookResultFragment().GetFragment(bookResult));
			
			template.AddParameter("ButtonJavascript", Resources.ReadEmbeddedText("MouseButton.js"));
			return template.Generate(searchResultTemplate);
		}
		
		public string GetVersesFragment(IEnumerable<IVerse> verses, string searchText)
		{
			
			string searchResultTemplate = Resources.ReadEmbeddedText("SearchResultFragment.html");
			var template = new HtmlTemplate();
			
			var searchTerms = searchText.Split(new char[]{' '}, StringSplitOptions.RemoveEmptyEntries);
			
			template.AddParameter("verses", verses.Select(verse => new VerseWithBoldTerms(verse, searchTerms)));
			return template.Generate(searchResultTemplate);
		}
	}
}

