// WideMargin. Simple fast bible software.
// Copyright (C) 2013  Daniel Hughes
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
using System;
using SharpSword;
using System.Collections.Generic;

namespace WideMargin.Database
{
	public class VerseWithBoldTerms : IVerse
	{
		public VerseWithBoldTerms (IVerse verse, IEnumerable<string> searchTerms)
		{
			Identifier = verse.Identifier;
			
			string text = verse.Text;
			foreach(var searchTerm in searchTerms)
			{
				text = MakeTermBold(searchTerm, text);
			}
			
			Text = text;
		}

		public IVerseIdentifier Identifier 
		{
			get;
			private set;
		}

		public string Text 
		{
			get ;
			private set;
		}
		
		string MakeTermBold(string term, string text)
		{
			int startIndex = 0;
			int indexOfTerm = text.IndexOf(term, startIndex, StringComparison.CurrentCultureIgnoreCase);
			while(indexOfTerm != -1)
			{
				text = text.Insert (indexOfTerm + term.Length,"</b>");
				text = text.Insert (indexOfTerm, "<b>");
				startIndex = indexOfTerm + term.Length + 7;
				indexOfTerm = text.IndexOf(term, startIndex, StringComparison.CurrentCultureIgnoreCase);
			}
			return text;
		}
	}
}

